# Unit --
#
#   base unit

inherit Unit Control
method Unit constructor {parent position} {
	UnitA ${objName}_abst $objName $position
	this inherited $parent ${objName}_abst	
}

method Unit destructor {} {
	this inherited
}

method Unit position {} {
	return [$this(abstraction) attribute position]
}


# UnitA --
#
#   unit abstraction

inherit UnitA Abstraction
method UnitA constructor {control position} {
	this inherited $control
	set this(position) $position
}


# UnitP --
#
#   unit presentation

inherit UnitP Presentation
method UnitP constructor {control canvas {size 2} {color blue}} {
	set SCALE 10

	this inherited $control
	set this(canvas) $canvas
	
	foreach {x y} [split [$this(control) position] ","] {
		set this(id) [$this(canvas) create rectangle $x $y [expr $x + $size] [expr $y + $size] -fill $color]
		$this(canvas) scale $this(id) 0 0 $SCALE $SCALE
	}
}

method UnitP destructor {} {
	$this(canvas) delete $this(id)
}